import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import javax.swing.*;

//-------------------------------------
class canfield extends JFrame implements Runnable, WindowListener {

static canfield mf;

Canvas  cnvs;
JButton sbar;

//-------------------------------------
boolean doauto, doit, domove, donew, doplay, doturn, fnlz, gamo, paus;
Cards   cdck;
Cards   rsrv;
Cards[] loff;
Cards[] pile;
Cards[] stck;
double  etim, gtim, itim, lsu;
Emitter emtr;
Font    emf, gmf, uif;
int     gamx, gamy, maxx, maxy, wxp, wyp;
int     nstk, uifs;
int     dix, diy;
int     mfrom, mto;
long    ctim, itck, otim;
MoteAL  motes;
Random  rndm;
String  stxt, uifn;
Thread  thrd;

//-------------------------------------
static final int UFSIZ   = 32;

static final int NSUIT   = 4;
static final int PSUIT   = 13;
static final int DCKSIZ  = (NSUIT*PSUIT);
static final int NOFF    = 4;
static final int NPLS    = 2;
static final int NSTK    = 4;
static final int RSIZ     = 13;

static final int FF        = 128;
static final double CSPEED = 2000.0;

static final String RLIT = "A23456789TJQK";
static final String SLIT = "][{}";
static final String NSTKLIT = "NSTK";
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT  = "WXP";
static final String WYPLIT  = "WYP";

static final double ITCK = 1.0;

//-------------------------------------
class AAuto implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  doauto = true;
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class ANewGame implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  donew = true;
}}

//-------------------------------------
void AppQuit() {
  StopThread();
  System.exit(0);
}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  AppQuit();
}}

//-------------------------------------
class AReset implements ActionListener {
public void actionPerformed(ActionEvent ae) {
File     f;
int      i, todo;
String   fc, fn, tkn;
String[] tkns;
  cdck.Clear();
  fn = System.getProperty("user.dir")+"/"+"canfield.svd"; 
  f = new File(fn);
  fc = Util.ReadTextFile(f, mf);
  tkns = fc.split("\n");
  todo = tkns.length;
  for (i=0; i<todo; i++) {
    tkn = tkns[i];
    if (tkn.length()>0) {
      cdck.Add((byte)Byte.valueOf(tkn));
    }
  }
  NewGameDeal();
}}

//-------------------------------------
boolean AutoPlay() {
boolean played;
int     cidx, i, idx;
int     fc, fr, fs, tc, tr, ts;
  played = false;
  i = 0;
  while((i<nstk)&&(!played)) {
    idx = stck[i].Size() - 1;
    if (idx >= 0) {
      fr = stck[i].CardRank(idx);
      fs = stck[i].CardSuit(idx);
      cidx = loff[fs].Size()-1;
      if (cidx<0) {
        if (fr==1) loff[fs].Add(stck[i].Deal());
      } else {
        tr = loff[fs].CardRank(cidx);
        if (fr == (tr+1)) {
          loff[fs].Add(stck[i].Deal());
          played = true;
        }
      }
    }
    i++;
  }
  SetDestinations();
  return(played);
}

//-------------------------------------
public canfield(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
  if (maxx>maxy) {
    wxp = 60;
    wyp = 90;
  } else {
    wxp = 90;
    wyp = 80;
  }
}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  PopupMain();
}}

//-------------------------------------
class CBClick extends MouseAdapter {
public void mouseClicked(MouseEvent me) {
int   act, col, colw, x, y;
  if (Moving()) return;
  if (doturn||doplay||domove) return;
  x = (int)me.getX();
  y = (int)me.getY();
  colw = (gamx)/(nstk+1);
  col = x/colw;
  if (col<0) col = 0;
  if (col>=(nstk+1)) col = nstk;
  if (mfrom==-1) {
    if (col==0) {
      if (y<diy) doturn = true;
      else if (y<(diy*2)) mfrom = nstk;
      else if (y<(diy*3)) mfrom = nstk+1;
    } else if (stck[col-1].Size()>0) mfrom = col-1;
  } else {
    if (col==0) doplay = true;
    else {
      if ((col-1)==mfrom) doplay = true;
      else {
        mto = col-1;
        domove = true;
      }
    }
  }
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
  if (kc == KeyEvent.VK_Q) AppQuit();
  if (kc == KeyEvent.VK_N) donew = true;
  if (kc==KeyEvent.VK_A) doauto = true;
  if (kc==KeyEvent.VK_T) doturn = true;
/*
  if ((kc>=KeyEvent.VK_1)&&(kc<=KeyEvent.VK_8)) {
    if (mfrom==-1) mfrom = kc-KeyEvent.VK_1;
    else {
      mto = kc-KeyEvent.VK_1;
      if (mto==mfrom) PlayFrom();
      else MoveFromTo();
    }
  }
*/
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
  gamy = cnvs.getHeight();
  gamx = cnvs.getWidth();
  dix = gamx/(nstk+1);
  diy = (dix*4)/3;
  gmf = new Font("Card Characters", Font.PLAIN, (diy*2)/5);
  SetDestinations();
}}

//-------------------------------------
void CheckGame() {
boolean hgam;
int     i, siz;
  hgam = true;
  for (i = 0; i < nstk; i++) {
    siz = stck[i].Size();
    if (siz>0) hgam = false;
  }
  if (Moving()) hgam = false;
  if (pile[0].Size()>0) hgam = false;
  if (pile[1].Size()>0) hgam = false;
  gamo = hgam;
}

//-------------------------------------
public void Initlz() {
Image     iimg;
Toolkit   tk;
URL       iurl;
  InitlzData();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
  iurl = this.getClass().getResource("/canfield.png");
  tk = Toolkit.getDefaultToolkit();
  iimg = tk.createImage(iurl);
  mf.setIconImage(iimg);
  StartThread();
}

//-------------------------------------
public void InitlzData() {
int  i;
Mote m;
  nstk = NSTK;
  rndm = new Random();
  emtr = new Emitter(rndm);
  cdck = new Cards();
  rsrv = new Cards();
  loff = new Cards[NOFF];
  for (i=0; i<NOFF; i++) loff[i] = new Cards();  
  pile = new Cards[NPLS];
  for (i=0; i<NPLS; i++) pile[i] = new Cards();  
  stck = new Cards[nstk];
  for (i=0; i<nstk; i++) stck[i] = new Cards();  
  motes = new MoteAL();
  for (i=0; i<=DCKSIZ; i++) {
    m = new Mote();
    motes.add(m);
  }
  doauto = false;
  domove = false;
  doplay = false;
  doturn = false;
  donew  = false;
  gamo = true;
  fnlz = true;
  paus = false;
  uifs = UFSIZ;
  itim = 0.0;
  itck = 0;
  stxt = "Click Here";
}

//-------------------------------------
public void InitlzUI() {
GraphicsEnvironment ge;
  gamx = (maxx*wxp)/100;
  gamy = (maxy*wyp)/100;
  try {
    emf = Font.createFont(Font.TRUETYPE_FONT, getClass().getResource("/CardCharacters.ttf").openStream());
    ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
    ge.registerFont(emf);
  } catch (Exception ex) {System.err.format("Exception: %s%n", ex);}
  gmf = emf.deriveFont(Font.PLAIN, (diy*3.0f)/7);
  uif = new Font(uifn, Font.BOLD, uifs);
  cnvs = new Canvas();
  cnvs.setBackground(new Color(64, 0, 0));
  cnvs.setFont(gmf);
  cnvs.addMouseListener(new CBClick());
  cnvs.addKeyListener(new CBKey());
  cnvs.addComponentListener(new CBResize());
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
  sbar.setBackground(new Color(128, 16, 16));
  sbar.setForeground(new Color(255, 255, 0));
}

//-------------------------------------
public void LayoutUI() {
  addWindowListener(this);
  mf.addKeyListener(new CBKey());
  mf.setSize(gamx, gamy+sbar.getHeight());
  mf.setLocation((maxx-gamx)/2, (maxy-(gamy+sbar.getHeight()))/2);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(cnvs, BorderLayout.CENTER);
  mf.setTitle("canfield");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
public static void main(String[] args) {
  System.out.println("starting canfield\n");
  mf = new canfield(args);
  mf.Initlz();
}

//-------------------------------------
void MoveFromTo() {
int   cfrom, cto;
  domove = false;
  cfrom = mfrom;
  cto = mto;
  mfrom = -1;
  mto = -1;
  if (cfrom==nstk) MoveFromToPile(cfrom, cto);
  else if (cfrom==nstk+1) MoveFromToReserve(cfrom, cto);
  else MoveFromToStack(cfrom, cto);
  SetDestinations();
}

//-------------------------------------
void MoveFromToPile(int cfrom, int cto) {
int   fc, fidx, fr, tc, tidx, tr;
  fidx = pile[1].Size() - 1;
  if (fidx<0) return;
  fc = pile[1].CardColor(fidx);
  fr = pile[1].CardRank(fidx);
  tidx = stck[cto].Size() - 1;
  if (tidx<0) {
    stck[cto].Add(pile[1].Deal());
    return;
  }
  tc = stck[cto].CardColor(tidx);
  tr = stck[cto].CardRank(tidx);
  if (fc==tc) return;
  if ((tr-fr)!=1) return;
  stck[cto].Add(pile[1].Deal());
}

//-------------------------------------
void MoveFromToReserve(int cfrom, int cto) {
int   fc, fidx, fr, tc, tidx, tr;
  fidx = rsrv.Size() - 1;
  if (fidx<0) return;
  fc = rsrv.CardColor(fidx);
  fr = rsrv.CardRank(fidx);
  tidx = stck[cto].Size() - 1;
  if (tidx<0) {
    stck[cto].Add(rsrv.Deal());
    return;
  }
  tc = stck[cto].CardColor(tidx);
  tr = stck[cto].CardRank(tidx);
  if (fc==tc) return;
  if ((tr-fr)!=1) return;
  stck[cto].Add(rsrv.Deal());
}

//-------------------------------------
void MoveFromToStack(int cfrom, int cto) {
int   fc, fidx, fr, i, nmov, tc, tidx, tr;
  fidx = stck[cfrom].di;
  if (fidx<0) fidx = 0;
  fc = stck[cfrom].CardColor(fidx);
  fr = stck[cfrom].CardRank(fidx);
  tidx = stck[cto].Size() - 1;
  if (tidx<0) {
    nmov = stck[cfrom].Size() - fidx;
    for (i=0; i<nmov; i++) stck[cto].Add(stck[cfrom].Deal(fidx));
    return;
  }
  tc = stck[cto].CardColor(tidx);
  tr = stck[cto].CardRank(tidx);
  if ((tr-fr)<1) {
    fidx += (fr-tr)+1;
    if (fidx>=stck[cfrom].Size()) fidx = stck[cfrom].Size() - 1;
    fc = stck[cfrom].CardColor(fidx);
    fr = stck[cfrom].CardRank(fidx);
  }
  if ((tr-fr)!=1) return;
  if (fc==tc) return;
  nmov = stck[cfrom].Size() - fidx;
  for (i=0; i<nmov; i++) stck[cto].Add(stck[cfrom].Deal(fidx));
}

//---------------------------------------------
boolean Moving() {
boolean rv;
int     i;
Mote    m;
  rv = false;
  for (i = 1; i <= DCKSIZ; i++) {
    m = motes.get(i);
    if (m.mx != 0.0) rv = true;
    if (m.my != 0.0) rv = true;
    if ((int)m.px != m.dx) rv = true;
    if ((int)m.py != m.dy) rv = true;
  }
  return(rv);
}

//-------------------------------------
void NewGame() {
int     i, j;
  donew = false;
  cdck.Clear();
  for (i = 1; i <= DCKSIZ; i++) if ((i%13) != 1) cdck.Add((byte)i);
  cdck.Shuffle(rndm);
  SaveGameFile();
  NewGameDeal();
}

//-------------------------------------
void NewGameDeal() {
int     i, j;
  for (i = 0; i < NOFF; i++) {
    loff[i].Clear();
    loff[i].Add((byte)((i*13)+1));
  }
  for (i = 0; i < NPLS; i++) pile[i].Clear();
  for (i = 0; i < nstk; i++) stck[i].Clear();
  rsrv.Clear();
  for (i=0; i<RSIZ; i++) rsrv.Add(cdck.Deal());
  rsrv.di = RSIZ-1;
  for (i=0; i<nstk; i++) {
    stck[i].Add(cdck.Deal());
    stck[i].di = 0;
  }
  do {
    pile[0].Add(cdck.Deal());
  } while (cdck.Size()>0);
  gamo = false;
  fnlz = true;
  gtim = 0.0f;
  lsu  = 0.0f;
  SetDestinations();
  mfrom = -1;
}

//-------------------------------------
void PlayFrom() {
int   cfrom, fidx, fr, fs, tidx, tr;
  doplay = false;
  cfrom = mfrom;
  mfrom = -1;
  if (cfrom==nstk) {
    fidx = pile[1].Size() - 1;
    if (fidx<0) return;
    fs = pile[1].CardSuit(fidx);
    fr = pile[1].CardRank(fidx);
    tidx = loff[fs].Size() - 1;
    if (tidx>=0) {
      tr = loff[fs].CardRank(tidx);
      if ((fr-tr)==1) loff[fs].Add(pile[1].Deal());
    } else if (fr==1) loff[fs].Add(pile[1].Deal());
  } else if (cfrom==nstk+1) {
    fidx = rsrv.Size()-1;
    if (fidx<0) return;
    fs = rsrv.CardSuit(fidx);
    fr = rsrv.CardRank(fidx);
    tidx = loff[fs].Size()-1;
    if (tidx>=0) {
      tr = loff[fs].CardRank(tidx);
      if ((fr-tr)==1) loff[fs].Add(rsrv.Deal());
    } else if (fr==1) loff[fs].Add(rsrv.Deal());
  } else {
    fidx = stck[cfrom].Size() - 1;
    if (fidx<0) return;
    fs = stck[cfrom].CardSuit(fidx);
    fr = stck[cfrom].CardRank(fidx);
    tidx = loff[fs].Size() - 1;
    if (tidx>=0) {
      tr = loff[fs].CardRank(tidx);
      if ((fr-tr)==1) loff[fs].Add(stck[cfrom].Deal());
    } else {
      if (fr==1) loff[fs].Add(stck[cfrom].Deal());
    }
  }
  SetDestinations();
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Auto Play");
  mi.setMnemonic('A');
  mi.addActionListener(new AAuto());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("New Game");
  mi.setMnemonic('N');
  mi.addActionListener(new ANewGame());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Reset");
  mi.setMnemonic('R');
  mi.addActionListener(new AReset());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(sbar, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"canfield.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//---------------------------------------------
void RenderCard(Graphics g, byte crd, boolean face) {
int       dx, dy, r, s;
Mote      m;
Rectangle br;
String    ds;
  m = motes.get(crd);
  dx = (int)m.px;
  dy = (int)m.py;
  g.setColor(new Color(0.0f, 0.0f, 1.0f, 1.0f));
  g.fillRect(dx, dy, dix, diy);
  g.setColor(new Color(1.0f, 1.0f, 1.0f, 1.0f));
  g.fillRect(dx+4, dy+4, dix-8, diy-8);
  if (face) {
    if (Cards.SCardColor(crd)==1) g.setColor(new Color(1.0f, 0.0f, 0.0f, 1.0f));
    else g.setColor(new Color(0.0f, 0.0f, 0.0f, 1.0f));
    r = Cards.SCardRank(crd)-1;
    ds = RLIT.substring(r, r+1);
    br = new Rectangle(dx, dy, dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
    br = new Rectangle(dx+(dix/2), dy+(diy/2), dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
    s = Cards.SCardSuit(crd);
    ds = SLIT.substring(s, s+1);
    br = new Rectangle(dx, dy+(diy/2), dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
    br = new Rectangle(dx+(dix/2), dy, dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
  }
}

//---------------------------------------------
void RenderCardSelected(Graphics g, byte crd, boolean face) {
int       dx, dy, r, s;
Mote      m;
Rectangle br;
String    ds;
  m = motes.get(crd);
  dx = (int)m.px;
  dy = (int)m.py;
  g.setColor(new Color(0.0f, 0.0f, 1.0f, 1.0f));
  g.fillRect(dx, dy, dix, diy);
  if (Cards.SCardColor(crd)==1) g.setColor(new Color(1.0f, 0.0f, 0.0f, 1.0f));
  else g.setColor(new Color(0.0f, 0.0f, 0.0f, 1.0f));
  g.fillRect(dx+4, dy+4, dix-8, diy-8);
  if (face) {
    g.setColor(new Color(1.0f, 1.0f, 1.0f, 1.0f));
    r = Cards.SCardRank(crd)-1;
    ds = RLIT.substring(r, r+1);
    br = new Rectangle(dx, dy, dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
    br = new Rectangle(dx+(dix/2), dy+(diy/2), dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
    s = Cards.SCardSuit(crd);
    ds = SLIT.substring(s, s+1);
    br = new Rectangle(dx, dy+(diy/2), dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
    br = new Rectangle(dx+(dix/2), dy, dix/2, diy/2);
    RenderTextCentered(g, ds, br, gmf);
  }
}

//---------------------------------------------
void RenderLayoffs(Graphics g) {
byte    crd;
int     i, j, siz;
  for (i = 0; i < NOFF; i++) {
    siz = loff[i].Size(); 
    for (j = 0; j < loff[i].Size(); j++) {
      crd = loff[i].Get(j);
      RenderCard(g, crd, true);
    }
  }
}

//---------------------------------------------
void RenderPiles(Graphics g) {
byte    crd;
int     i, j;
  for (i = 0; i < NPLS; i++) {
    for (j = 0; j < pile[i].Size(); j++) {
      crd = pile[i].Get(j);
      if ((mfrom==NSTK)&&(i==1)) RenderCardSelected(g, crd, (j>=pile[i].di));
      else RenderCard(g, crd, (j>=pile[i].di)&&(i==1));
    }
  }
}

//-------------------------------------
void RenderPS(Graphics g, double et) {
boolean doit;
int     rx, ry;
  itim += et;
  doit = false;
  if (itim>ITCK) {
    itim = 0.0;
    itck++;
    doit = true;
  }
  if (doit) {
    if ((itck%2)==0) {
      emtr.tint = new Color(255, 0, 0);
      emtr.life = 1.0;
      emtr.mspeed = 800.0;
      emtr.numm = 200;
      emtr.msiz = 4;
      rx = rndm.nextInt(gamx/2)+(gamx/4);
      ry = rndm.nextInt(gamy/2)+(gamy/4);
      emtr.Fire(new Point(rx, ry));
    }
    if ((itck%3)==0) {
      emtr.tint = new Color(0, 255, 0);
      emtr.life = 2.0;
      emtr.mspeed = 600.0;
      emtr.numm = 400;
      emtr.msiz = 8;
      rx = rndm.nextInt(gamx/2)+(gamx/4);
      ry = rndm.nextInt(gamy/2)+(gamy/4);
      emtr.Fire(new Point(rx, ry));
    }
    if ((itck%5)==0) {
      emtr.tint = new Color(0, 0, 255);
      emtr.life = 3.0;
      emtr.mspeed = 400.0;
      emtr.numm = 800;
      emtr.msiz = 12;
      rx = rndm.nextInt(gamx/2)+(gamx/4);
      ry = rndm.nextInt(gamy/2)+(gamy/4);
      emtr.Fire(new Point(rx, ry));
    }
  }
  emtr.Update(et);
  emtr.Render(g);
}

//---------------------------------------------
void RenderReserve(Graphics g) {
byte    crd;
int     i;
  for (i = 0; i < rsrv.Size(); i++) {
    crd = rsrv.Get(i);
    if (mfrom==nstk+1) RenderCardSelected(g, crd, (i>=0));
    else RenderCard(g, crd, (i>=0));
  }
}

//---------------------------------------------
void RenderStacks(Graphics g) {
byte    crd;
int     i, j;
  for (i = 0; i < nstk; i++) {
    for (j = 0; j < stck[i].Size(); j++) {
      crd = stck[i].Get(j);
      if (i==mfrom) RenderCardSelected(g, crd, (j>=stck[i].di));
      else RenderCard(g, crd, (j>=stck[i].di));
    }
  }
}

//---------------------------------------------
void RenderStatus(Graphics g) {
String  s;
  if ((gtim-lsu)<0.4) return;
  lsu = gtim;
  s = "Time ";
  s += String.format("%.02f", gtim);
  sbar.setText(s);
}

//-------------------------------------
void RenderTextCentered(Graphics g, String s, Rectangle r, Font f) {
FontMetrics fm;
int         x, y;
  fm = g.getFontMetrics(f);
  x = r.x+(r.width-fm.stringWidth(s))/2;
  y = r.y+((r.height-fm.getHeight())/2)+fm.getAscent();
  g.setFont(f);
  g.drawString(s, x, y);
}

//-------------------------------------
public void run() {
BufferStrategy bs;
Graphics       g;
  cnvs.createBufferStrategy(2);
  bs = cnvs.getBufferStrategy();
  doit = true;
  while (doit) {
    ctim = System.nanoTime();
    etim = (ctim - otim)/1000000000.0;
    otim = ctim;
    if (!paus) {
      g = bs.getDrawGraphics();
      g.clearRect(0, 0, gamx, gamy);
      if (donew) NewGame();
      if (doturn) TurnPile();
      if (domove) MoveFromTo();
      if (doplay) PlayFrom();
      if (!gamo) {
        gtim += etim;
        if (doauto) if (!Moving()) doauto = AutoPlay();
      }
      if (!gamo) CheckGame();
      if (gamo) RenderPS(g, etim);
      else {
        if (!paus) {
          Update(etim);
          RenderPiles(g);
          RenderLayoffs(g);
          RenderStacks(g);
          RenderReserve(g);
        }
      }
      RenderStatus(g);
      g.dispose();
      bs.show();
    }
    try {
       Thread.sleep(10);
    } catch (InterruptedException ex) {}
  }
}

//-------------------------------------
void SaveGameFile() {
byte   b;
File   savf;
int    i, ne;
String fn, s;
  s = "";
  ne = cdck.crds.size();
  for (i=0; i<ne; i++) {
    b = cdck.crds.get(i);
    s += Byte.toString(b);
    s += "\n";
  }
  fn = System.getProperty("user.dir")+"/"+"canfield.svd"; 
  savf = new File(fn);
  Util.SaveTextFile(savf, s, mf);
}

//-------------------------------------
void SetDestinations() {
byte  crd;
int   dx, dy, i, j, offy;
Mote  m;
  offy = diy;
  dy = (diy*30) / 100;
  for (i = 0; i < nstk; i++) {
    dx = (dix * (i+1));
    for (j = 0; j < stck[i].Size(); j++) {
      crd = stck[i].Get(j);
      m = motes.get(crd);
      m.dx = dx;
      m.dy = offy+(dy*j);
    }
  }
  for (i = 0; i < NOFF; i++) {
    dx = (dix * (i+1));
    for (j = 0; j < loff[i].Size(); j++) {
      crd = loff[i].Get(j);
      m = motes.get(crd);
      m.dx = dx;
      m.dy = 0;
    }
  }
  for (i = 0; i < NPLS; i++) {
    for (j = 0; j < pile[i].Size(); j++) {
      crd = pile[i].Get(j);
      m = motes.get(crd);
      m.dx = 0;
      m.dy = offy*i;
    }
  }
  for (i=0; i<rsrv.Size(); i++) {
    crd = rsrv.Get(i);
    m = motes.get(crd);
    m.dx = 0;
    m.dy = offy*2;
  }
}

//-------------------------------------
private void StartThread() {
  if ((thrd==null) || !doit) {
    otim = System.nanoTime();
    thrd = new Thread(this);
    thrd.start();
  }
}

//-------------------------------------
private void StopThread() {
  if (thrd!=null) {
    doit = false;
    try {
      thrd.join();
    } catch (InterruptedException ex) {}
    thrd = null;
  }
}

//-------------------------------------
void TurnPile() {
int   i, nt;
  doturn = false;
  if (pile[0].Size()>0) {
    pile[1].Add(pile[0].Deal());
    pile[1].di = pile[1].Size() - 1;
  } else while (pile[1].Size()>0) pile[0].Add(pile[1].Deal());
  SetDestinations();
}

//-------------------------------------
void Update(double etim) {
byte    crd;
int     i, j;
  for (i = 0; i < NOFF; i++) {
    for (j = 0; j < loff[i].Size(); j++) {
      crd = loff[i].Get(j);
      UpdateCard(crd, etim);
    }
  }
  for (i = 0; i < nstk; i++) {
    for (j = 0; j < stck[i].Size(); j++) {
      crd = stck[i].Get(j);
      UpdateCard(crd, etim);
    }
  }
  for (i = 0; i < NPLS; i++) {
    for (j = 0; j < pile[i].Size(); j++) {
      crd = pile[i].Get(j);
      UpdateCard(crd, etim);
    }
  }
  for (i=0; i<rsrv.Size(); i++) {
    crd = rsrv.Get(i);
    UpdateCard(crd, etim);
  }
}

//-------------------------------------
void UpdateCard(byte crd, double etim) {
int    dx, dy, px, py;
Mote   m;
  m = motes.get(crd);
  px = (int)m.px;
  py = (int)m.py;
  dx = m.dx - px;
  dy = m.dy - py;
  if (Math.abs(dx) < FF) {
    m.mx = 0.0f;
    m.px = (double)m.dx;
  } else if (dx < 0) m.mx = -CSPEED;
  else m.mx = CSPEED;
  if (Math.abs(dy) < FF) {
    m.my = 0.0f;
    m.py = (double)m.dy;
  } else if (dy < 0) m.my = -CSPEED;
  else m.my = CSPEED;
  m.px += m.mx * etim;
  m.py += m.my * etim;
//  motes.set(crd, m);
}

//-------------------------------------
public void windowActivated(WindowEvent e) { paus = false; }
public void windowDeactivated(WindowEvent e) { paus = true; }
public void windowDeiconified(WindowEvent e) { paus = false; }
public void windowIconified(WindowEvent e) { paus = true; }
public void windowClosing(WindowEvent e) { doit = false; }
public void windowClosed(WindowEvent e) { doit = false; }
public void windowOpened(WindowEvent e) { paus = false; }

//-------------------------------------
}
